<?php
/**
 * Copyright © FiloBlu S.p.A. 2019. All rights reserved.
 */

namespace FiloBlu\Rma\Helper;

class Data extends \Magento\Rma\Helper\Data
{
    
    /**
     * Checks whether the item can be returned based on configuration validity_days 
     *
     * @param  int|\Magento\Sales\Model\Order $order
     * @return bool
     */
    public function isValid($order)
    {
        //error_log(__METHOD__);
        return true;
        
        if (is_object($order)) {
            $order_date = $order->getCreatedAt();
        }
        if (!is_numeric($order)) {
            throw new \Magento\Framework\Exception\LocalizedException(__('Please check this order for errors.'));
        }
        $validity_days = $this->scopeConfig->getValue(
            Rma::XML_PATH_VALIDITY_DAYS,
            \Magento\Store\Model\ScopeInterface::SCOPE_STORE
        );
        
    }

    /**
     * Checks for ability to create RMA
     *
     * @param  int|\Magento\Sales\Model\Order $order
     * @param  bool $forceCreate - set yes when you don't need to check config setting (for admin side)
     * @return bool
     */
    public function canCreateRma($order, $forceCreate = false)
    {
        //error_log(__METHOD__);
        $items = $this->getOrderItems($order);
        if ($items->count() && ($forceCreate || ($this->isEnabled() && $this->isValid($order)))) {
            return true;
        }

        return false;
    }

    /**
     * Get whether selected product is returnable
     *
     * @param \Magento\Catalog\Model\Product $product
     * @param int|null $storeId
     * @return bool
     */
    public function canReturnProduct($product, $storeId = null)
    {
        //error_log(__METHOD__);
        $isReturnable = $product->getIsReturnable();

        if ($isReturnable === null) {
            $isReturnable = \Magento\Rma\Model\Product\Source::ATTRIBUTE_ENABLE_RMA_USE_CONFIG;
        }
        switch ($isReturnable) {
            case \Magento\Rma\Model\Product\Source::ATTRIBUTE_ENABLE_RMA_YES:
                return true;
            case \Magento\Rma\Model\Product\Source::ATTRIBUTE_ENABLE_RMA_NO:
                return false;
            default:
                //Use config and NULL
                return $this->scopeConfig->getValue(
                    \Magento\Rma\Model\Product\Source::XML_PATH_PRODUCTS_ALLOWED,
                    \Magento\Store\Model\ScopeInterface::SCOPE_STORE,
                    $storeId
                );
        }
    }

}
