<?php
/**
 * Created by PhpStorm.
 * User: jderosa
 * Date: 30/10/19
 * Time: 20.03
 */

namespace FiloBlu\Rma\Setup;
use Magento\Framework\Setup\UpgradeDataInterface;
use Magento\Framework\Setup\ModuleDataSetupInterface;
use Magento\Framework\Setup\ModuleContextInterface;
use FiloBlu\Rma\Helper\InstallHelper;
use Symfony\Component\Console\Output\ConsoleOutput as Output;


class UpgradeData implements UpgradeDataInterface
{
    /**
     * @var Output
     */
    protected $output;

    /**
     * @var InstallHelper
     */
    protected $installHelper;


    /**
     * UpgradeData constructor.
     * @param Output $output
     * @param InstallHelper $installHelper
     */
    public function __construct(Output $output, InstallHelper $installHelper)
    {
        $this->output = $output;
        $this->installHelper = $installHelper;
    }

    /**
     * @param ModuleDataSetupInterface $setup
     * @param ModuleContextInterface $context
     */
    public function upgrade(ModuleDataSetupInterface $setup, ModuleContextInterface $context)
    {
        if (version_compare($context->getVersion(), "2.0.0", "<")) {
            try {
                $this->installHelper->addNewOrderStatus($setup);
                $this->installHelper->addNewReasonOption($setup);
                $this->installHelper->addNewRmaItem($setup);
                $this->installHelper->hideReasonOther($setup);
            } catch (\Exception $e) {
                $this->output->writeln("Error while creating new order status : $e");
            }
        }
    }
}